using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Frief
{
    public class cuffs : MVRScript
    {
        #region PluginInfo    
        public string pluginAuthor = "Hazmhox and Frief";
        public string pluginName = "Shackels";
        public string pluginVersion = "1";
        public string pluginDate = "09/02" + "/2022";
        public string pluginDescription = @"Used to open and close the cuffs";
        #endregion

        #region Vars    



        public GameObject player;
        public GameObject KS_Shed;

        protected JSONStorableFloat ScrubA;
        protected JSONStorableFloat ScrubB;

		
	    protected JSONStorableFloat yRotation;
        protected JSONStorableFloat yRotation2;

        private float previousValue1;
        private float previousValue2;
		

        private float previousZValue;
        private float currentZValue;

        private string objectNameSearchString = "OBJ";
	    public Transform ObjectRoot;
        public Transform Cuff_Open;
        

		
        private bool editorInitialized = false;
        private int initLoops = 0;
        private int maxInitLoops = 1500; // 3600 for one minute

        #endregion

        public override void Init()
        {
            try
            {
				if (containingAtom.type != "CustomUnityAsset")
				{
	                SuperController.LogError("Cuffs - Please add this script on a Custom Unity Asset ( script disabled).");
  	                return;
  		        }


                //**************  ScrubA
                ScrubA = new JSONStorableFloat("Open/Close", 0f, OnSliderChanged, 0f, 43f);
                RegisterFloat(ScrubA);
                CreateSlider(ScrubA, false);
                          

               				
                          
			

              // A tiny bit of help to give some info to your fellow creator and/or player
                JSONStorableString helpText = new JSONStorableString("About",
                    "<color=#000><size=35><b>About</b></size></color>\n\n" +
                    "<color=#333>" +
                    "Frief CuffDoors Plugin , Credits to Hazmhox.\n\n" +					
                    "The Cuffs can be triggered using Acidbubbles Timeline to open and close.\n\n" +
                    "if you have a Cuff open and save the scene the position of a door is also saved.\n\n" +
                    "</color>" );
               UIDynamic helpTextfield = CreateTextField(helpText, true);
                helpTextfield.height = 1100.0f;

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        // Update is called with each rendered frame by Unity
        void Update()
        {
			// I don't know why the fuck this asset does not get the children properly during the loading process, so I'm checking the singleton
			// In reality, that's even cleaner to do it that way
			if( initLoops < maxInitLoops && editorInitialized == false && !SuperController.singleton.isLoading ) {
                initLoops++;
                InitEditor();
            }
			
			if( initLoops == maxInitLoops ) {
                SuperController.LogError("Cuff: This CUA could not be initialized properly. Please select a compatible object and reload the script.");
                initLoops++; // To avoid spamming the log with the error
            }
        }

        private bool InitEditor() {
            if( editorInitialized == true ) return true;
        
            ObjectRoot = getObjectRoot( containingAtom.reParentObject, "Gag" );
            if( ObjectRoot == null ) {
                return false;
            }
			
            Cuff_Open = ObjectRoot.Find("Joint");
          
			
			 
            // I found my transforms, now the rest
            if( Cuff_Open) {
				editorInitialized = true;
				
				OnSliderChanged( 0f );
			
				return true;
            } else {
                SuperController.LogError("Cuff : your CUA is missing mandatory components.");
                initLoops = maxInitLoops; // We don't have what we need, we consider the initialization failed
                return false;
            }
        
            return false;
        }

		// Recursive function searching for a transform containing the string set in objectNameSearchString
		// It is used the first time for the initialization of the script
		// This script NEEDS to use a string "containing" your original because the cloning of the original asset will add "Clone" behind it.
		private Transform getObjectRoot( Transform parent, string rootName ) {
			foreach( Transform child in parent )
			{
				if( child.name.Contains(rootName) ) {
					return child;
				} else {
					Transform childSearch = getObjectRoot(child,rootName);
					if (childSearch != null) return childSearch;
				}
			}
			
			return null;
		}
		
		private Transform getChildRoot( Transform parent, string searchName ) {
			foreach( Transform child in parent )
			{
				SuperController.LogMessage(">>" + child.name);
				if( child.name == searchName ) {
					
					return child;
				} else {
					Transform childSearch = getChildRoot(child,searchName);
					if (childSearch != null) return childSearch;
				}
			}
			
			return null;
		}

        void OnSliderChanged( float rotation )
        {
            
            {
				if( Cuff_Open == null ) return;
				
                var Slider1 = ScrubA.val;
                var a = Slider1 - previousValue1;
                //Cuff_Open.transform.Rotate(Vector3.forward * a * 90);
                //Cuff_Open.transform.localRotation = Quaternion.Euler(a, 0f, 0f);
                Cuff_Open.localRotation = Quaternion.Euler(Slider1, 0f, 0f);
                previousValue1 = ScrubA.val;
            }

        }
     

    }
	
}